﻿/*
 * Licensed under the EUPL, Version 1.1 or – as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence. You may
 * obtain a copy of the Licence at:
 * 
 * http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * Licence for the specific language governing permissions and limitations under
 * the Licence.
 */
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

using eu.stork.peps.auth.commons;
using eu.stork.peps.auth.engine;
using System.Collections.Generic;

//
// author: AMA – Agência para a Modernização Administrativa IP, PORTUGAL (www.ama.pt)
//
namespace eu.stork.sp
{
    public partial class WebForm1 : System.Web.UI.Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            SAMLResponse samlResponse = (SAMLResponse)Session[SessionConstants.clientResponse];
            Session.Clear();
            if (samlResponse == null)
            {
                Label lblNoResponse = new Label();
                lblNoResponse.Text = "<br/><br/><br/><br/><h3>" + GetLocalResourceObject("LblSessionExpired").ToString() + "</h3><br/>";
                attributeList.Controls.Add(lblNoResponse);
                return;
            }

            if (samlResponse.ErrorCode != SAMLConstants.ErrorCodes.VALID ||
                samlResponse.StatusCode > 0 ||
                samlResponse.StatusCode != SAMLConstants.StatusCode.SUCCESS)
            {
                Label lblLoginFailed = new Label();
                lblLoginFailed.Text = "<br/><br/><h2>" + GetLocalResourceObject("LblLoginFailed").ToString() + "</h2><br/>";
                attributeList.Controls.Add(lblLoginFailed);

                if (samlResponse.ErrorCode != SAMLConstants.ErrorCodes.VALID)
                {
                    string errorDescription = SAMLConstants.ErrorCodes.GetErrorDescription(samlResponse.ErrorCode);
                    Label lbl = new Label();
                    lbl.Text += "<span id='title'>" + GetLocalResourceObject("LblError").ToString() + "</span>" + errorDescription + "<br/>";
                    attributeList.Controls.Add(lbl);
                    return;
                }
                if (samlResponse.StatusCode > 0)
                {
                    Label lblStatusCode = new Label();
                    lblStatusCode.Text += "<span id='title'>" + GetLocalResourceObject("LblStatusError").ToString() + "</span>"+ samlResponse.StatusCodeStr + "<br/>";
                    attributeList.Controls.Add(lblStatusCode);
                }

                if (samlResponse.StatusCode != SAMLConstants.StatusCode.SUCCESS)
                {
                    if (samlResponse.StatusMessage != null)
                    {
                        Label lblDetail = new Label();
                        lblDetail.Text += "<span id='title'>" + GetLocalResourceObject("LblSubStatusError").ToString() + "</span>" + samlResponse.SubStatusCodeStr + "<br/>";
                        lblDetail.Text += "<span id='title'>" + GetLocalResourceObject("LblMessageError").ToString() + "</span>" + samlResponse.StatusMessage + "<br/>";
                        attributeList.Controls.Add(lblDetail);
                    }
                    return;
                }
            }
            Label l = new Label();
            l.Text = "<br/></br><h2>" + GetLocalResourceObject("LblLoginSucceeded").ToString() + "</h2><div id='space'></div>" +
                     "<h2>" + GetLocalResourceObject("LblRequestedData").ToString() + "</h2><div id='space'></div>" +
                     "<table class='tabla' colpadding=4><tbody><tr class='filatit'><td>"+GetLocalResourceObject("LblAttributeName").ToString()+"</th><th>"+GetLocalResourceObject("LblAttributeValue").ToString()+"</th><th>"+GetLocalResourceObject("LblAttributeValue").ToString()+"</th></tr>";
            foreach (int attrId in samlResponse.GetAttributeIds())
                if (samlResponse.isAttributeComplex(attrId))
                {
                    Dictionary<string, string> attrValue = samlResponse.GetAttributeComplexValue(attrId);
                    l.Text += "<tr class='filaresult'><td>" + CitizenAttributes.Instance.GetFriendlyName(attrId) + "</td><td>";
                    foreach ( String key in attrValue.Keys)
                    {
                        l.Text += key + "=" + attrValue[key] + "<br/>";
                    }
                    l.Text += "</td><td>";
                    l.Text += samlResponse.GetAttributeStatusStr(attrId) + "</td></tr>";
                }
                else
                {
                    l.Text += "<tr><td>" + CitizenAttributes.Instance.GetFriendlyName(attrId) + "</td><td>" +
                        samlResponse.GetAttributeValue(attrId) + "</td><td>" +
                        samlResponse.GetAttributeStatusStr(attrId) + "</td></tr>";
                }
            l.Text += "</Table>";
            attributeList.Controls.Add(l);
        }
    }
}
