﻿/*
 * Licensed under the EUPL, Version 1.1 or – as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence. You may
 * obtain a copy of the Licence at:
 * 
 * http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * Licence for the specific language governing permissions and limitations under
 * the Licence.
 */
using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.SessionState;
using System.Text;
using System.Xml;

using eu.stork.peps.auth.engine;
using eu.stork.peps.auth.commons;

//
// author: AMA – Agência para a Modernização Administrativa IP, PORTUGAL (www.ama.pt)
//
namespace eu.stork.sp.Handlers
{
    public class ResponseHandler : IHttpHandler, IRequiresSessionState
    {
        public void ProcessRequest(HttpContext context)
        {
            string samlResponseField = ConfigurationSettingsHelper.GetCriticalConfigSetting("samlResponseField");
            string requestData = context.Request.Form[samlResponseField];

            byte[] reqDataB64 = Convert.FromBase64String(requestData);
            string reqData = Encoding.UTF8.GetString(reqDataB64);

            XmlDocument xml = new XmlDocument();
            xml.PreserveWhitespace = true;
            xml.LoadXml(reqData);

            SAMLEngine.Instance.Init(HttpContext.Current.Server.MapPath(".") + "/bin/");
            SAMLResponse samlResponse = SAMLEngine.Instance.HandleResponse(xml);
            context.Session.Add(SessionConstants.clientResponse, samlResponse);

            context.Response.Redirect("SuccessPage.aspx");
        }

        public bool IsReusable
        {
            get { return false; }
        }
    }
}
